package maps.test;

import java.util.HashMap;
import java.util.Map;

import javax.naming.NamingException;
import javax.transaction.HeuristicMixedException;
import javax.transaction.HeuristicRollbackException;
import javax.transaction.NotSupportedException;
import javax.transaction.RollbackException;
import javax.transaction.SystemException;

import org.drools.KnowledgeBase;
import org.drools.KnowledgeBaseFactory;
import org.drools.builder.KnowledgeBuilder;
import org.drools.builder.KnowledgeBuilderError;
import org.drools.builder.KnowledgeBuilderErrors;
import org.drools.builder.KnowledgeBuilderFactory;
import org.drools.builder.ResourceType;
import org.drools.impl.KnowledgeBaseImpl;
import org.drools.io.Resource;
import org.drools.io.ResourceFactory;
import org.drools.runtime.StatefulKnowledgeSession;
import org.drools.runtime.process.ProcessInstance;
import org.jbpm.test.JBPMHelper;

/**
 * Hello world!
 *
 */
public class AppOk 
{
    public static void main( String[] args ) throws NamingException, NotSupportedException, SystemException, SecurityException, IllegalStateException, RollbackException, HeuristicMixedException, HeuristicRollbackException
    {
        
    	JBPMHelper.startH2Server();
    	JBPMHelper.setupDataSource();
    	
    	System.out.println( "Elaborating...." );
      
        KnowledgeBuilder kbuilder = KnowledgeBuilderFactory.newKnowledgeBuilder();
        Resource r = ResourceFactory.newClassPathResource("test.bpmn");
      
		kbuilder.add(r, ResourceType.BPMN2);
		
		

        KnowledgeBuilderErrors errors = kbuilder.getErrors();
        if (errors.size() > 0) {
            for (KnowledgeBuilderError error : errors)
              System.out.println("KnowledgeBuildError: " + error);
    
        }
	
        KnowledgeBase kbase = kbuilder.newKnowledgeBase();
        

       

       
        for(int i = 0; i < 1000; i++) {

             System.out.println("Run " + i);
              
             StatefulKnowledgeSession  session=  JBPMHelper.newStatefulKnowledgeSession(kbase);
            
               
			ProcessInstance s = session.startProcess("com.sample.bpmn",new HashMap<String, Object>() ); 
             int currentId = session.getId();
             long pId=s.getId();
          
               session.dispose();
              StatefulKnowledgeSession s2 = JBPMHelper.newStatefulKnowledgeSession(kbase);
            
               ProcessInstance p2 = s2.getProcessInstance(pId);
              
           
              s2.dispose();
              System.out.println("When loading session after dispose---->"+   ((KnowledgeBaseImpl) kbase).getRuleBase().getRuleBaseEventListeners().size());
              
                System.gc();
            
               

        }      
        System.out.println("Finally got---->"+   ((KnowledgeBaseImpl) kbase).getRuleBase().getRuleBaseEventListeners().size());
        
    }
    
    
   
}
